dict = {}
words = 0

function add_dict(word, vowels)
  if dict[vowels] == nil then
    dict[vowels] = {}  
  end
  dict[vowels][#dict[vowels]+1] = word
  words = words + 1
end

function count_vowels(word)
  local vowels = 0
  for c in string.gmatch(word, "[aeiouAEIOU]") do
    vowels = vowels + 1
  end
  return vowels
end

--function to process a file
function process_file(f)
  for line in io.lines(f) do
    if string.match(line, "'s") == nil then
      add_dict(line, count_vowels(line))
    end
  end
end

process_file(arg[1])

print("Processed "..words.." words")
io.write("Outputting to files... ")

for v = 1, #dict, 1 do
  io.write(v.." ")
  f = io.open(v.."vowels", "w")
  for w = 1, #dict[v], 1 do
    f:write(dict[v][w].."\n")
  end
  io.close(f)
end
io.write("\n")
